dojo.provide('ibm._CheckTreeNode');

dojo.require("dijit.Tree");
dojo.require("dijit.form.CheckBox");

dojo.declare('ibm._CheckTreeNode', dijit._TreeNode, {
	isExpandable: false,
	checkbox: null,
	postCreate: function(){
		// set label, escaping special characters
		this.setLabelNode(this.label);
	
		// set expand icon for leaf
		this._setExpando();
	
		// set icon and label class based on item
		this._updateItemClasses(this.item);
	
		if(this.isExpandable){
			dijit.setWaiState(this.labelNode, "expanded", this.isExpanded);
		}
	},
	
	setLabelNode: function(label) {
		
		var id = 'chk$root';
		//var value = '';
		var checked = false;
		
		if (!this.item.root) {
			var value = this.tree.model.store.getValue(this.item, 'value');
			var kids = this.tree.model.store.getValue(this.item, 'children');
			
			id = this.tree.model.store.getValue(this.item, 'uid');
			
			var index = id.lastIndexOf('_');
			
			checked = ('true' == this.tree.model.store.getValue(this.item, 'checked'));
			
			if (!checked && index > -1) {
				var parentId = 'chk$' + id.substring(0, index);
				var parentChkbox = dijit.byId(parentId);
				if (parentChkbox)
					checked = parentChkbox.checked;
			}
			
			id = 'chk$' + id;
		}
		
		var chkBox = new dijit.form.CheckBox({
			name: "checkBox",
            //value: value,
            checked: checked,
            parentNode: this,
            id: id
		},
		"checkBox");
		
//		var chkBox = new dijit.form.CheckBox();
//		chkBox.id = id;
//		chkBox.value = value;
//		chkBox.parentNode = this;
		var chk = chkBox.domNode;
		chk.type = 'checkbox';
		
		if (!this.item.root) {
			//**************************************************************
			//* Method for handling a checkbox click, to update the appropriate 
			//* list of checkboxes selected
			//**************************************************************
			chkBox.onClick = function(event) {
					
				updateFilterJSON(this);
			};
		}
		
		dojo.place(chk, this.iconNode, 'replace');
		this.checkNode = chk;
		this.checkbox = chkBox;
	},
	
	destroy: function(/*Boolean*/ preserveDom){
		
		if (this.checkbox)
			this.checkbox.destroy();
		
		this.inherited(arguments);
	},

	getCheckBox: function() {
		return this.checkbox;
	}
});

dojo.provide('ibm.CheckTree');
dojo.declare('ibm.CheckTree', dijit.Tree, {
	_clickTarget: null,
	_createTreeNode: function(args) {
	
		var node = new ibm._CheckTreeNode(args);
		this._expandNode(node);
		return node;
	},

	getIconClass: function(item, opened) {
	
		return '';
	},
	
	expandAll: function(callback) {
		
		if (!this.rootNode) {
			console.debug("!this.rootNode");
			if(callback)
				callback();
			return;
		}
		
		this._expandAll(this.rootNode, callback);
	},
	
	_expandAll: function(node, callback) {
		
		// summary: This function will expand all the nodes
		// below the given node in the given tree inclusively
		// (if a node is not specified, it begin with the root node).
		if (!node)
			node = this.rootNode;
		
		if (!node) {
			if(callback)
				callback();
			return;
		}
		
		var def = this._expandNode(node);
		if (def) {
			def.addCallback(function() {
				var children = node.getChildren();
				var count = children.length;
				if(count == 0 && callback)
					callback();
				for(var i = 0; i < children.length; i++) {
					this._expandAll(children[i], function() {
//						if(--count == 0 && callback)
//							callback();
					});
				}
			});
		}
	},
	
	postCreate: function(){
		this.inherited(arguments);
		this.expandAll(function() {
			console.debug("expandAll executed.");
		});
	}
});
