

String.prototype.trim = function () {
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
}

function sizeButtons() {
	var minWidth=60;

	if(document.getElementById("ok").offsetWidth < minWidth){
		document.getElementById("ok").style.width = minWidth+"px";
	}
	if(document.getElementById("cancel").offsetWidth < minWidth){
		document.getElementById("cancel").style.width = minWidth+"px";
	}
}

function enableButtons() {
	document.getElementById("ok").disabled = false;
}

function closeChildDialog()
{
//	try {
//		if (workingSetDialog)
//			workingSetDialog.close();
//	}
//	catch(e) {}
}

function updateTree()
{
	if (FILTER_JSON_DATA_ITEMS!=null)
	{
		showFilterTree(getDisplayJSON(FILTER_JSON_DATA_ITEMS));
		return;
	}

	dojo.xhrGet({
		url: '../filter/filterRetriever',
		content: {
			lang: USER_LOCALE
		},
		handleAs: "json",
		load: function(data, ioArgs) {
			
			var filters = loadFilterQuery();
			FILTER_JSON_DATA_ITEMS = data;
	
			if (filters==null || filters=='')
				setAllChecks(FILTER_JSON_DATA_ITEMS.items,true);
			else
				updateChecks(FILTER_JSON_DATA_ITEMS.items,filters);
			showFilterTree(getDisplayJSON(data.items));
		},
		error: function() {
			return '';
		}
	});
}

function setAllChecks(items,value)
{
	for (var i=0;i<items.length;i++)
	{
		setCheckedKids(items[i],value);
	}
}

function updateChecks(items,filters)
{

	for (var i=0;i<items.length;i++)
	{
		var chk = 'false';
		for (var f=0;f<filters.length;f++)
		{
			if (items[i].value==filters[f])
				chk = 'true';
		}
		items[i].checked = chk;
				
		setCheckedAncestors(items[i].uid,(items[i].checked=="true"));
		
		updateChecks(items[i].children,filters);
	}
}

function getDisplayJSON(items)
{

	var json = 
		"{\n"+
		"  identifier:'uid',\n"+
		"  label:'description',\n"+
		"  items:\n"+
		"  [\n";
		
		
	for (var i=0;i<items.length;i++)
	{
		var tmp = getDisplayJSONChild(items[i],4);
		if (tmp!=""){
			json+=tmp+",\n";
		}
	}
	
	if (json.charAt(json.length-2)==',')
		json = json.substring(0,json.length-2);
	json+="  ]\n";
	json+="}\n";
	
	DISPLAY_JSON = json;
	return json;
}

function getDisplayJSONChild(child, tabs)
{
	var json="";
	
	if (child.description!=null)
	{
		json+=tab(tabs)+"{\n";
		json+=tab(tabs+2)+"uid:'"+child.uid+"',\n";
		if (child.value!=null)
			json+=tab(tabs+2)+"value:'"+child.value+"',\n";
		else
			json+=tab(tabs+2)+"value:'undefined',\n";
		json+=tab(tabs+2)+"id:'"+child.id+"',\n";
		json+=tab(tabs+2)+"description:'"+child.description+"',\n";
		json+=tab(tabs+2)+"checked:'"+child.checked+"',\n";
		json+=tab(tabs+2)+"children:\n";
		json+=tab(tabs+2)+"[\n";
		
		var kids = child.children;
		for (var k = 0; k<kids.length; k++) {
			var tmp = getDisplayJSONChild(kids[k],tabs+4);
			if (tmp!="")
				json+=tmp+",\n";
		}
		
		if (json.charAt(json.length-2)==',')
			json = json.substring(0,json.length-2);
		
		
		json+=tab(tabs+2)+"]\n";
		json+=tab(tabs)+"}\n";
	}
	else
	{
		var kids = child.children;
		for (var k = 0; k<kids.length; k++) {
			var tmp = getDisplayJSONChild(kids[k],tabs);
			if (tmp!="")
				json+=tmp+",\n";
		}
		if (json.charAt(json.length-2)==',')
			json = json.substring(0,json.length-2);
	}
	return json;
}

function tab(num)
{
	var t="";
	for (var i=0;i<num;i++){
		t+=" ";
	}
	return t;
}

function updateCheckedStateForAllChildrenSelected(parentUID, checked, basicJson) {
	
	if (checked || parentUID == '') return basicJson;
	
	checked = isSiblingsAllChecked(parentUID, basicJson);
	
	if (!checked) return basicJson;
	
	return updateJSONData(checked, parentUID, basicJson);
}

function isSiblingsAllChecked(itemID, json) {
	
	if (json == '' || itemID == '')
		return false;
	
	var index = 0;
	var isAllChecked = false;
	
	do {
		index = json.indexOf("'" + itemID + "_", index);
		if (index < 0) break;
		
		index = json.indexOf('checked', index);
		var nextIndex = json.indexOf("',", index);
		isAllChecked = (json.substring(index+9, nextIndex) == 'true');
		
	} while (isAllChecked && index > -1);
	
	return isAllChecked;
}

function resetTree() {

	FILTER_JSON_DATA_ITEMS = null;
	updateTree();
}

function showFilterTree(data) {
	
	var dataItems = dojo.fromJson(data);
	var filterTreeStore = new dojo.data.ItemFileWriteStore({jsId:"filterTreeStore", data: dataItems});
	
	var tree = dijit.byId("treeFilter");
	if (tree) {
		dojo.byId("workingSetContainer").removeChild(tree.domNode);
		tree.destroy();
	}
	
	var filterTreeModel = new dijit.tree.ForestStoreModel({
		store: filterTreeStore,
		jsId: filterTreeModel,
		showRoot: false
	});
	
	var treeFilter = new ibm.CheckTree({
		model: filterTreeModel,
		showRoot: false,
		style: "width:90%; border-left:10px;",
		isExpanded: "true",
		label:"Filter tree",
		isCheckbox: true,
		id: "treeFilter"
	});
	
	dojo.byId("workingSetContainer").appendChild(treeFilter.domNode);
}

function openWhatIsThis() {
	
	var parent = getParent();
//	if (window.opener != null)
//		parent = window.opener.parent;
//	else
//		parent = window.parent.parent.parent;
	
	var topicWhatIsThis = "?topic=" + TOPIC_WHAT_IS_THIS;
	parent.HelpFrame.location.replace(
			parent.HelpFrame.location.protocol +
			"//" +
			parent.HelpFrame.location.host + 
			parent.HelpFrame.location.pathname +
			topicWhatIsThis);
}

function getParentUID(tokens) {
	
	var parentUID = '';
	
	for (var i = 0; i < tokens.length-1; i++) {
		if (parentUID != '')
			parentUID += '_';
		parentUID += tokens[i];
	}
	
	return parentUID;
}

function getItem(id)
{
	var items = FILTER_JSON_DATA_ITEMS.items;
	var tokens = id.substring(id.indexOf("$")+1).split('_');
	
	var item;
	for (var t=0;t<tokens.length;t++)
	{
		item = items[tokens[t]];
		items = item.children;
	}
	
	return item;
}

function setCheckedKids(item,value)
{
	if (item.children.length>0){
		for (var i=0;i<item.children.length;i++){
			setCheckedKids(item.children[i],value);
		}
	}
	item.checked=value+"";
	var box = dijit.byId("chk$"+item.uid);
	if (box!=null)
		box.setChecked(value);
}

function getParentItem(id)
{
	var items = FILTER_JSON_DATA_ITEMS.items;
	var tokens = id.split('_');
	
	var item = null;
	for (var t=0; t<(tokens.length-1); t++)
	{
		item = items[tokens[t]];
		items = item.children;
	}
	
	return item;
}

function setCheckedAncestors(id, checked) {
	
	var item = getParentItem(id);
	if (!item) return;
	
	if (checked) {
		checked = isSiblingsChecked(item.children, id);
	}
	
//	setCheckedAncestors('' + item.uid, checked);
	
	if (item.checked != ('' + checked)) {
		item.checked = '' + checked;
		var box = dijit.byId("chk$" + item.uid);
		if (box)
			box.setChecked(checked);
		setCheckedAncestors('' + item.uid, checked);
	}
}

function isSiblingsChecked(children, id) {
	
	for (var i = 0; i < children.length; i++) {
		var item = children[i];
		if (item && item.uid != id 
				&& item.checked == 'false')
			return false;
	}
	return true;
}
/*
function setCheckedAncestors(item)
{
	if (item.children.length==0)
		return item.checked=="true";

	var chk = true;	
	for (var i=0;i<item.children.length;i++)
	{
		if (!setCheckedAncestors(item.children[i]))
		{
			item.checked=false;
			chk = false;
		}

	}
	var box = dijit.byId("chk$"+item.uid);
	
	if (box!=null)
		box.setChecked(chk);
	return chk;
}
*/
function updateParentData(uid, checked) {
	
	var tokens = uid.split('_');
	
	var parentUID = getParentUID(tokens);
	if (parentUID == '') return;
	
	var isAllChecked = isAllSiblingsChecked(parentUID, uid);
	checked = isAllChecked ? checked : false;
	
	var chkbox = dijit.byId('chk$' + parentUID);
	if (chkbox)
		chkbox.setChecked(checked);
	
	BASIC_JSON = updateJSONData(checked, parentUID, BASIC_JSON);
	ADVANCED_JSON = updateJSONData(checked, parentUID, ADVANCED_JSON);
	
	updateParentData(parentUID, checked);
}

function isAllSiblingsChecked(parentUID, uid) {
	
	var tokens = parentUID.split('_');
	
	var children = getChildren(tokens);
	if (!children || children.length == 0) return false;
	
	var isAllChecked = true;
	for (i = 0; isAllChecked && i < children.length; i++) {
		var child = children[i];
		if (child) {
			if (child.uid == uid)
				continue;
			
			var chkbox = dijit.byId('chk$' + child.uid);
			isAllChecked = chkbox.checked;
		}
	}
	
	return isAllChecked;
}

function updateFilterJSON(chkbox) {
	
	if (!chkbox) return;
	
	var item = getItem(chkbox.id);
	setCheckedKids(item, chkbox.checked);
//	setCheckedAncestors(getItem("chk$0"));
	
	var id = chkbox.id.substring(chkbox.id.indexOf("$")+1);
	setCheckedAncestors(id, chkbox.checked);

	document.getElementById("ok").disabled = false;
}

function updateJSONData(checked, itemID, json) {
	
	if (json == '')
		return '';
	
	var index = json.indexOf("'" + itemID + "'");
	if (index < 0) return json;
	
	index = json.indexOf('checked', index);
	var nextIndex = json.indexOf("',", index);
	var first = json.substring(0, index+9);
	var last = json.substring(nextIndex);
	
	return (first + checked + last);
}

function buildQuery(parent,item)
{
	var op = "|";
	if (item!=null && item.type=='AND')
		op = "^";

	var query = "";
	var kids = item.children;
	if (kids.length>0)
	{		
		for (var k=0;k<kids.length;k++)
		{
			var subquery = buildQuery(item,kids[k]);
			if (subquery!="")
			{
				if (query=="")
					query = "("+subquery+")";
				else 
					query = query.substring(0,query.length-1)+op+subquery+")";
			}
		}
	}
	else if (item.checked==true || item.checked=='true')
	{
		query=item.value;
	}
	
	return query;
}

function selectAll()
{
	setAllChecks(FILTER_JSON_DATA_ITEMS.items,true);
}

function areAllChecked(dataItems)
{
	for (var d=0;d<dataItems.length;d++)
	{
		if (dataItems[d].checked==false || dataItems[d].checked=='false')
			return false;
	}
	return true;
}
		

function updateFilters() 
{
	var dataItems = FILTER_JSON_DATA_ITEMS.items;
	if (dataItems==null)
		return;
	
	if (areAllChecked(dataItems))
	{
		setCookie("filters","");
		var parent = getParent();
		var href = parent.location.href;
		if (href.indexOf('?')>-1)
		{
			var query = href.substring(href.indexOf('?'));
			if (query.indexOf('scope=')>-1)
			{
				var s = query.substring(0,query.indexOf('scope=')-1);
				var e = query.substring(query.indexOf('scope='));
				if (e.indexOf('&')>-1){
					e = e.substring(e.indexOf('&'));
					query = s+e;
				}else if (s!='?'){
					query = s;
				}
			}
			
			href = href.substring(0,href.indexOf('?'))+query;
		}
		parent.location.replace(href);
		return;
	}
	
	var scopes="";
	
	for (var d=0;d<dataItems.length;d++)
	{
		var tmp = buildQuery(null,dataItems[d],"");
		if (tmp!="")
		{
			if (scopes=="")
				scopes="("+tmp+")";
			else
				scopes=scopes.substring(0,scopes.length-1)+"|"+tmp+")";
		}
	}
	
	while (scopes.length>4 &&
		scopes.charAt(0)=='(' &&
		scopes.charAt(1)=='(' &&
		scopes.charAt(scopes.length-1)==')' &&
		scopes.charAt(scopes.length-2)==')')
	{
		scopes = scopes.substring(1,scopes.length-1);	
	}
	
	saveFilterQuery(scopes);	


	if (scopes=='')
		scopes="(none)";

	
	var parent = getParent();
	var href = parent.location.href;
	if (href.indexOf('?')>-1)
	{
		var query = href.substring(href.indexOf('?'));
		if (query.indexOf('scope=')>-1)
		{
			var s = query.substring(0,query.indexOf('scope=')-1);
			var e = query.substring(query.indexOf('scope='));
			if (e.indexOf('&')>-1){
				e = e.substring(e.indexOf('&'));
				query = s+e;
			}else if (s!='?'){
				query = s;
			}
		}
		
		href = href.substring(0,href.indexOf('?'))+query;
	}
	
	if (scopes!='')
	{
		if (href.indexOf('?')>-1)
			href+='&scope='+scopes;
		else
			href+='?scope='+scopes;
	}

	parent.location.replace(href);
}

function saveFilterQuery(query)
{
	if (query=='')
		query='(none)';
	setCookie("filters",query);
}


function loadFilterQuery()
{
	var str = getCookie("filters");
	if (str==null)
		return null;
		
	while (str.indexOf("^")>-1)
		str = str.replace("^"," ");
	while (str.indexOf("|")>-1)
		str = str.replace("|"," ");
	while (str.indexOf("(")>-1)
		str = str.replace("(","");
	while (str.indexOf(")")>-1)
		str = str.replace(")","");
	
	var filters = str.split(" ");
	return filters;
}

function getScopeValues(child) {
	
	var tokens = child.value.split(SCOPE_SEPARATOR);
	var values = '';
	
	for (var i = 0; i < tokens.length; i++) {
		var token = tokens[i];
		if (!isTokenExists(SCOPE, token, SCOPE_SEPARATOR)) {
			if (values != '')
				values += SCOPE_SEPARATOR;
			values += token;
		}
	}
	
	return values;
}

function getParentFilterScopeValues(uid) {
	
	if (!uid) return '';
	
	var tokens = uid.split('_');
	if (tokens.length != 2) return '';
	
	var parentUID = tokens[0];
	if (parentUID == '') return '';
	
	var parent = getItemFromBasicJsonById(parentUID);
	if (!parent || parent.value == 'undefined' || parent.checked != 'true')
		return '';
	
	return getScopeValues(parent);
}

function getItemFromBasicJsonById(uid) {
	
	var jsonData = dojo.fromJson(BASIC_JSON);
	var children = jsonData.items;
	
	for (var i = 0; i < children.length; i++) {
		var child = children[i];
		if (child && child.uid == uid)
			return child;
	}
	
	return null;
}

function getChildren(tokens) {
	
	if (!tokens || tokens.length < 1) return null;
	
	var children = FILTER_JSON_DATA_ITEMS.items;
	
	for (var i = 0; i < tokens.length; i++) {
		var token = parseInt(tokens[i]);
		var child = children[token];
		if (child && child.children)
			children = child.children;
	}
	
	return children;
}

function getChildFilterScopeValues(uid) {
	
	if (!uid) return '';
	
	var values = getChildrenFilterValues(uid);
	var tokens = values.split(SCOPE_SEPARATOR);
	values = '';
	
	for (var i = 0; i < tokens.length; i++) {
		var token = tokens[i];
		if (!isTokenExists(SCOPE, token, SCOPE_SEPARATOR)) {
			if (values != '')
				values += SCOPE_SEPARATOR;
			values += token;
		}
	}
	
	return values;
}

function getChildrenFilterValues(uid) {
	
	if (!uid) return '';
	
	var tokens = uid.split('_');
	if (tokens.length != 2) return '';
	
	var children = getChildren(tokens);
	if (!children || children.length == 0) return '';
	
	var result = '';
	for (i = 0; i < children.length; i++) {
		var child = children[i];
		if (child) {
			if (result != '')
				result += SCOPE_SEPARATOR;
			result += child.value.replace(/\s/g, '');
		}
	}
	
	return result;
}

function isTokenExists(values, token, separator) {
	
	if (!values || values.length == 0)
		return false;
	
	var index = values.indexOf(token);
	if (index == -1)
		return false;
	
	var len = index + token.length;
	var sep1 = values.substring(index-1, index);
	var sep2 = values.substring(len, len+separator.length);
	if ((index == 0 || (sep1 == separator)) 
			&& (len == values.length || (sep2 == separator)))
		return true;
	
	return false;
}

function getChildIDPath(uid) {
	
	if (!uid) return '';
	
	var tokens = uid.split('_');
	if (tokens.length < 1) return '';
	
	var children = FILTER_JSON_DATA_ITEMS.items;
	var result = '';
	
	for (var i = 0; i < tokens.length; i++) {
		var token = parseInt(tokens[i]);
		var child = children[token];
		if (child) {
			if (result != '')
				result += FILTER_ID_SEPARATOR;
			result += child.id;
			
			if (!child.children)
				break;
			
			children = child.children;
		}
	}
	
	return result;
}

function getSubCookiesfilters(filters, id, level) {
	
	var vals = '';
	var tokens = filters.split(FILTER_SEPARATOR);
	
	for (var i = 0; i < tokens.length; i++) {
		var subtokens = tokens[i].split(FILTER_ID_SEPARATOR);
		if (subtokens[level] && subtokens[level] == id) {
			var subvals = '';
			for (var j = 0; j < subtokens.length; ++j) {
				if (subvals != '')
					subvals += FILTER_ID_SEPARATOR;
				subvals += subtokens[j];
			}
			if (subvals != '') {
				if (vals != '')
					vals += FILTER_SEPARATOR;
				vals += subvals;
			}
		}
	}
	
	return vals;
}

function getParent()
{
	var o = window.opener;
	if (o==null)
		o = window;
		
	return o.top;
}
