

var filterData;

function initMenu(locale)
{
	dojo.require("dijit.Menu");
    dojo.require("dijit.MenuSeparator");
    dojo.require("dijit.CheckedMenuItem");
    dojo.require("dijit.form.DropDownButton");
    
    
	dojo.registerModulePath("ibm", "../../dojotoolkitext/ibm");
	dojo.require("ibm.widget.JazzMenu");
	dojo.require("ibm.widget.MenuCategory");
	dojo.require("ibm.widget.PersistentDropDownButton");

	var menu = new ibm.widget.JazzMenu({});
	
	dojo.xhrGet({
		url: '../filter/filterRetriever',
		content: {
			lang: locale
		},
		handleAs: "json",
		load: function(data, ioArgs) {
		
			filterData = data;			
			var checkedFilters = loadFilterQuery();

			for (var i=0;i<data.items.length;i++)
				addTreeToMenu(menu,data.items[i],checkedFilters);

			menu.addChild(new dijit.MenuSeparator());
			
			menu.addChild(new dijit.MenuItem({
				label: '<a href="javascript:void()" class="menuClose">Close</a>',
				onClick: function(){
					button._closeDropDown();
					saveFilters();
				}
			}));
		},
		error: function() {
			return '';
		}
	});
	
	
    var button = new ibm.widget.PersistentDropDownButton({
        iconClass: "Button",
        name: "FilterMenuButton",
        dropDown: menu,
        id: "filterMenuButton"
    });
    dojo.byId("filterMenuButtonDiv").appendChild(button.domNode);
}


function addTreeToMenu(menu,node,checkedFilters)
{
	if (node.description!=null)
	{
		// Category Header
		if (node.value==null){
			menu.addChild(new ibm.widget.MenuCategory({
				label: '<span class="menuCategory">'+node.description+'</span>'
			}));
		}
		// Filter value
		else{
			menu.addChild(new dijit.CheckedMenuItem({
				label: '<span class="menuValue">'+node.description+'</span>',
				checked: contains(checkedFilters,node.value)
			}));
		}
	
	}
	for (var c=0;c<node.children.length;c++)
	{
		addTreeToMenu(menu,node.children[c],checkedFilters);	
	}	
}

function contains(array,value)
{
	for (var a=0;a<array.length;a++)
		if (array[a]==value)
			return true;
	return false;	
}

function saveFilters()
{
	var dataItems = filterData.items;
	if (dataItems==null)
		return;
	
	var query="";
	
	for (var d=0;d<dataItems.length;d++)
	{
		var tmp = buildQuery(null,dataItems[d],"");
		if (tmp!="")
		{
			if (query=="")
				query="("+tmp+")";
			else
				query=query.substring(0,query.length-1)+"|"+tmp+")";
		}
	}
	
	while (query.length>4 &&
		query.charAt(0)=='(' &&
		query.charAt(1)=='(' &&
		query.charAt(query.length-1)==')' &&
		query.charAt(query.length-2)==')')
	{
		query = query.substring(1,query.length-1);	
	}
	
	saveFilterQuery(query);	
}

function saveFilterQuery(query)
{
	if (query=='')
		query='(none)';
	setCookie("filters",query);
}

function loadFilterQuery()
{
	var str = getCookie("filters");
	if (str==null)
		return new Array(0);
		
	while (str.indexOf("^")>-1)
		str = str.replace("^"," ");
	while (str.indexOf("|")>-1)
		str = str.replace("|"," ");
	while (str.indexOf("(")>-1)
		str = str.replace("(","");
	while (str.indexOf(")")>-1)
		str = str.replace(")","");
	
	var filters = str.split(" ");
	
	
	return filters;
}

function buildQuery(parent,item)
{
	var op = "|";
	if (item!=null && item.type=='AND')
		op = "^";

	var query = "";
	var kids = item.children;
	if (kids.length>0)
	{		
		for (var k=0;k<kids.length;k++)
		{
			var subquery = buildQuery(item,kids[k]);
			if (subquery!="")
			{
				if (query=="")
					query = "("+subquery+")";
				else 
					query = query.substring(0,query.length-1)+op+subquery+")";
			}
		}
	}
	else if (item.checked==true || item.checked=='true')
	{
		query=item.value;
	}
	
	return query;
}


function getElementsByClass(className)
{
	var all = document.getElementsByTagName("*");
	var match = [];
	var count = 0;
	
	for(var a=0;a<all.length;a++)
	{
		if (all[a].getAttribute("class")!=null && all[a].getAttribute("class").indexOf(className)>-1){
			match[count] = all[a];
			count++;
		}	
	}
	return match;
}